include:
  - template: 'Auto-DevOps.gitlab-ci.yml'

variables:
  # TEST_DISABLED: 1
  STAGING_ENABLED: 1
  INCREMENTAL_ROLLOUT_MODE: manual

dast_environment_deploy:
  needs:
  - build

  
# dast:
#   needs: []
#   variables:
#     DAST_WEBSITE: http://demo.testfire.net/
#     DAST_BROWSER_SCAN: "true"
#     DAST_FULL_SCAN_ENABLED: "false"
    # DAST_WEBSITE: http://webscantest.com/react/16/
    # DAST_WEBSITE: http://testasp.vulnweb.com/
    # DAST_AUTH_URL: 'http://webscantest.com/react/16/login-register'
    # DAST_USERNAME: testuser
    # DAST_PASSWORD: testpass
    # DAST_USERNAME_FIELD: 'name:login'
    # DAST_PASSWORD_FIELD: 'name:passwd'
    # DAST_SUBMIT_FIELD: 'name:submit_login'

review:
  image: alpine:latest
  script:
  - echo "Deploying to Kubernetes"
  - echo "Done!"
  needs: []
  environment:
    name: sample/$CI_COMMIT_REF_NAME
    url: "https://gitlab-gold.gitlab.io/tpoffenbarger/ado/mr-7-review-app/"
  rules:
  - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
    when: never
  - if: '$REVIEW_DISABLED'
    when: never
  - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'

stop_review:
  script:
    - echo "shutting down environment"
  environment:
    name: sample/$CI_COMMIT_REF_NAME
    action: stop
  allow_failure: true
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: never
    - if: '$REVIEW_DISABLED'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
      when: manual


test:
  stage: test
  image: alpine:latest
  script:
  - cp tests/results.xml result.xml
  - 'echo "Code coverage: 85.29%"'
  coverage: '/Code coverage: \d+\.\d+/'
  artifacts:
    expire_in: 30 days
    paths:
    - 'result.xml'
    reports:
      junit: 'result.xml'
      metrics: m.txt

integration:
  stage: dast
  needs:
  - review
  image:
    name: "$SECURE_ANALYZERS_PREFIX/dast:$DAST_VERSION"
  variables:
    GIT_STRATEGY: none
  allow_failure: true
  script:
    - wget http://robotframework.org/WebDemo/report.html
    - wget http://robotframework.org/WebDemo/log.html
  artifacts:
    paths:
    - report.html
    - log.html
    expire_in: 14 days
    expose_as: 'Integration Test Results'
  rules:
    - if: $DAST_DISABLED
      when: never
    - if: $DAST_DISABLED_FOR_DEFAULT_BRANCH &&
          $CI_DEFAULT_BRANCH == $CI_COMMIT_REF_NAME
      when: never
    - if: $CI_DEFAULT_BRANCH != $CI_COMMIT_REF_NAME &&
          $REVIEW_DISABLED && $DAST_WEBSITE == null &&
          $DAST_API_SPECIFICATION == null
      when: never
    - if: $CI_COMMIT_BRANCH &&
          $CI_KUBERNETES_ACTIVE &&
          $GITLAB_FEATURES =~ /\bdast\b/
    - if: $CI_COMMIT_BRANCH &&
          $GITLAB_FEATURES =~ /\bdast\b/ &&
          $DAST_WEBSITE
    - if: $CI_COMMIT_BRANCH &&
          $GITLAB_FEATURES =~ /\bdast\b/ &&
          $DAST_API_SPECIFICATION



# metrics:
#   script:
#   - mv .gitlab/.metrics.txt metrics.txt
#   artifacts:
#     reports:
#       metrics: metrics.txt
#   rules:
#   - if: $CI_COMMIT_BRANCH == 'master'   # Execute jobs when a new commit is pushed to master branch
#   - if: $CI_MERGE_REQUEST_ID            # Execute jobs in merge request context

before_script:
  - export K8S_SECRET_GITLAB_PROJECT_ID=${CI_PROJECT_ID}
  - export K8S_SECRET_GITLAB_PROJECT_PATH=${CI_PROJECT_PATH}
  - export K8S_SECRET_GITLAB_PROJECT_PATH_SLUG=${CI_PROJECT_PATH_SLUG}
  - export K8S_SECRET_GITLAB_PROJECT_TITLE=${CI_PROJECT_TITLE}
  - export K8S_SECRET_GITLAB_PROJECT_NAME=${CI_PROJECT_NAME}
  - export K8S_SECRET_GITLAB_PROJECT_URL=${CI_PROJECT_URL}
  - export K8S_SECRET_GITLAB_COMMIT_SHA=${CI_COMMIT_SHA}
  - export K8S_SECRET_GITLAB_COMMIT_SHORT_SHA=${CI_COMMIT_SHORT_SHA}
  - export K8S_SECRET_GITLAB_PROJECT_URL=${CI_PROJECT_URL}
  - export K8S_SECRET_GITLAB_SERVER_VERSION=${CI_SERVER_VERSION}
  - export K8S_SECRET_GITLAB_RUNNER_VERSION=${CI_RUNNER_VERSION}

